VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Bucket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim parent As frmMain
Dim c_isfilling As Boolean
Dim undoch As Changes

Public Property Get isFilling() As Boolean
    isFilling = c_isfilling
End Property

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, x As Single, y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + x)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If
    
    Dim tmptile As Integer
    If Button = vbLeftButton Then
        tmptile = parent.tilesetleft
    Else
        tmptile = parent.tilesetright
    End If
    
    If tmptile = 217 Or tmptile = 219 Or tmptile = 220 Then
        Exit Sub
    End If
    
    If parent.clip.pasting Then
        MsgBox "You can't fill a selection pasted from the clipboard, apply it first by deselecting"
        'normally this should happen on mouseup, but because we invoke
        ' a msgbox the mouseup doesn't occur
        SharedVar.MouseDown = False
        Exit Sub
    ElseIf parent.sel.selalreadymoved Then
        MsgBox "You can't fill a selection that has already been moved. Reselect the area where you want to fill"
        SharedVar.MouseDown = False
        Exit Sub
    End If

        
    Dim fillinselectiononly As Boolean
    fillinselectiononly = (parent.sel.selstate = append)
            
    If fillinselectiononly And _
     Not (parent.shpdraw.Left - 2 <= x And _
         x <= parent.shpdraw.Left + parent.shpdraw.width + 1 + 2 And _
         parent.shpdraw.Top - 2 <= y And _
         y <= parent.shpdraw.Top + parent.shpdraw.Height + 1 + 2) Then
         'if we have a selection, but didn't click in it
         'do nothing
         Exit Sub
    End If
    
    parent.undoredo.ResetRedo
    Set undoch = New Changes
    
    Dim sourcetilenr As Integer
    sourcetilenr = parent.getTile(curtilex, curtiley)
            
    If isTileSpecial(parent, curtilex, curtiley) Then
        Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch, False, sourcetilenr)
    End If
            
    Call Fill(sourcetilenr, tmptile, curtilex, curtiley, undoch, fillinselectiononly, (frmGeneral.toolbartop.Buttons("FillInScreen").value = tbrPressed))
    parent.mapchanged = True
    
'    If undoch <> "" Then
        Call parent.undoredo.AddToUndo(undoch)
'    Else
'        Call parent.undoredo.ResetUndo
'    End If
End Sub

Sub MouseMove()
    'no way we're using bucket at move, it will crash like hell
End Sub

Sub MouseUp()
    'nothing to do on up
End Sub


Sub Fill(tilenr As Integer, fillnr As Integer, ByVal x As Integer, ByVal y As Integer, undoch As Changes, Optional fillinselection = False, Optional fillscreenonly = True, Optional ByVal stack As Long = 50000)
    
    parent.MousePointer = vbHourglass
    c_isfilling = True
    
    Dim done(1023, 1023) As Boolean
    Dim px() As Long
    Dim py() As Long
    Dim Pstart As Long
    Dim Pstop As Long
    Dim Pcount As Long
    Dim Colour As Integer
    
    Dim Lx As Integer
    Dim Ly As Integer
    
    Dim Sloop As Long
    ReDim px(0)
    ReDim py(0)

    Lx = x
    Ly = y
    
    Pstart = 0
    Pstop = 0
    px(0) = Lx
    py(0) = Ly
    Dim count As Long
    
    Dim lbsx As Integer
    Dim lbsy As Integer
    Dim hbsx As Integer
    Dim hbsy As Integer
    lbsx = Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))
    hbsx = Int((parent.hScr.value + parent.picpreview.width) / (TileW * parent.magnifier.Zoom))
    lbsy = Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))
    hbsy = Int((parent.vscr.value + parent.picpreview.Height) / (TileH * parent.magnifier.Zoom))

    GoSub AddPoints
    While Pstart < Pstop
        
        Lx = px(Pstart)
        Ly = py(Pstart)
        If Not (Lx < 0 Or Ly < 0 Or Lx > 1023 Or Ly > 1023) Then
            If fillinselection Then
                If Not parent.sel.IsInSelection(Lx, Ly) Then
                    GoTo skiploop
                End If
            ElseIf Not fillinselection And fillscreenonly Then
                If (Lx < lbsx Or Ly < lbsy Or Lx > hbsx Or Ly > hbsy) Then
                    GoTo skiploop
                End If
            End If
            
            Colour = parent.getTile(Lx, Ly)
            If Not (done(Lx, Ly) = True Or Colour <> tilenr) Then
                Pcount = Pcount + 1
                done(Lx, Ly) = True
                
                count = count + 1
                
                Call parent.setTile(Lx, Ly, fillnr, undoch, True)
                
                'it will prolly go faster if we directly set the pixel to the
                'pixel map, rather than calling updateleveltile,
                'becuase updateleveltile also calculates if it falls
                'in preview, which in unnecessary
                
                Call SetPixel(parent.pic1024.hdc, Lx, Ly, TilePixelColor(parent.getTile(x, y)))
              '  Call UpdateLevelTile(Lx, Ly, False)
    '                piccurrent.PSet (Lx, Ly), vbblue
            '    DoEvents
                GoSub AddPoints
            End If
        End If
skiploop:
        Pstart = Pstart + 1
        
    Wend
'but because we handled it directly, we need to update the level
'too,not only the preview
Call parent.UpdateLevel
c_isfilling = False

parent.MousePointer = 0
Exit Sub

AddPoints:

    If Pstart > stack Then
        For Sloop = Pstart To Pstop
            px(Sloop - stack) = px(Sloop)
            py(Sloop - stack) = py(Sloop)
        Next Sloop
        ReDim Preserve px(Pstop - stack)
        ReDim Preserve py(Pstop - stack)
        Pstart = Pstart - stack
        Pstop = Pstop - stack
    End If
    ReDim Preserve px(Pstop + 4)
    ReDim Preserve py(Pstop + 4)
    Pstop = Pstop + 1
    px(Pstop) = Lx + 1
    py(Pstop) = Ly
    Pstop = Pstop + 1
    px(Pstop) = Lx
    py(Pstop) = Ly + 1
    Pstop = Pstop + 1
    px(Pstop) = Lx - 1
    py(Pstop) = Ly
    Pstop = Pstop + 1
    px(Pstop) = Lx
    py(Pstop) = Ly - 1

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    
End Sub

