VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClipB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim c_pasting As Boolean

Dim clip() As Integer
Dim clipbsizex As Integer
Dim clipbsizey As Integer

Dim undoch As Changes

Dim parent As frmMain

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Private Sub Class_Initilialize()
    c_pasting = False
End Sub

Public Property Get pasting() As Boolean
    pasting = c_pasting
End Property

Public Property Let pasting(newpasting As Boolean)
    c_pasting = newpasting
End Property

Function getTile(X As Integer, Y As Integer) As Integer
    getTile = clip(X, Y)
End Function


Sub CutOrCopy(cutmode As Boolean, startx As Integer, starty As Integer, endx As Integer, endy As Integer)
    If parent.sel.selstate = append Then
    
        If cutmode Then
            parent.undoredo.ResetRedo
            undoch = New Changes
        End If
        
        Call parent.sel.StopSelecting
        
        Dim str As String
        str = "DCMETiles" & ":" & Abs(startx - endx) + 1 & ":" & Abs(starty - endy) + 1 & ":"
        
        Dim i As Integer
        Dim j As Integer
        For j = starty To endy
            For i = startx To endx
                str = str & parent.getTile(i, j) & ":"
                
                If cutmode Then
                    'once copied to the string, remove it
                    Call parent.setTile(i, j, 0, undoch)
                    Call parent.UpdateLevelTile(i, j, False)
                End If
            Next
        Next
        
        Clipboard.Clear
        
        Clipboard.SetText str
        
        If cutmode Then Call parent.undoredo.AddToUndo(undoch)
        
        parent.updatePreview
    End If
    
End Sub

Sub Paste()
    Dim str As String
    str = Clipboard.GetText
    
    Dim parts() As String
    parts = Split(str, ":")
            
    If parts(0) <> "DCMETiles" Then
        Exit Sub
    End If
    
    Call parent.sel.StopSelecting
    c_pasting = True
    
    clipbsizex = val(parts(1))
    clipbsizey = val(parts(2))
    
    ReDim clip(clipbsizex, clipbsizey)
    
    
    parent.picclipboard.Width = clipbsizex * (TileW * parent.magnifier.Zoom)
    parent.picclipboard.Height = clipbsizey * (TileH * parent.magnifier.Zoom)
    
    parent.picclipboard.Cls
    Dim i As Integer
    Dim j As Integer
    Dim index As Integer
    index = 3
    For j = 0 To clipbsizey - 1
        For i = 0 To clipbsizex - 1
            clip(i, j) = val(parts(index))
            
            If clip(i, j) < -1 Or clip(i, j) > 255 Then
                'little error correction
                clip(i, j) = 0
            End If
            
            If parent.magnifier.UsingPixels Then
                Call SetPixel(parent.picclipboard.hdc, i, j, TilePixelColor(clip(i, j)))
            Else
                If clip(i, j) = 217 Then
                    SetStretchBltMode parent.picclipboard.hdc, HALFTONE
                    StretchBlt parent.picclipboard.hdc, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), 2 * (TileW * parent.magnifier.Zoom), 2 * (TileH * parent.magnifier.Zoom), frmGeneral.picspecial.hdc, 16, 0, 2 * TileW, 2 * TileH, vbSrcCopy
                ElseIf clip(i, j) = 219 Then
                    SetStretchBltMode parent.picclipboard.hdc, HALFTONE
                    StretchBlt parent.picclipboard.hdc, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), 6 * (TileW * parent.magnifier.Zoom), 6 * (TileH * parent.magnifier.Zoom), frmGeneral.picspecial.hdc, 128, 0, 6 * TileW, 6 * TileH, vbSrcCopy
                ElseIf clip(i, j) = 220 Then
                    SetStretchBltMode parent.picclipboard.hdc, HALFTONE
                    StretchBlt parent.picclipboard.hdc, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), 5 * (TileW * parent.magnifier.Zoom), 5 * (TileH * parent.magnifier.Zoom), frmGeneral.picspecial.hdc, 48, 0, 5 * TileW, 5 * TileH, vbSrcCopy
                ElseIf clip(i, j) <> 0 Then
                    BitBlt parent.picclipboard.hdc, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.piczoomtileset.hdc, ((clip(i, j) - 1) Mod 19) * (TileW * parent.magnifier.Zoom), Int((clip(i, j) - 1) / 19) * (TileH * parent.magnifier.Zoom), vbSrcCopy
                Else
                    parent.picempty.Width = TileW * parent.magnifier.Zoom
                    parent.picempty.Height = TileH * parent.magnifier.Zoom
                    BitBlt parent.picclipboard.hdc, i * (TileW * parent.magnifier.Zoom), j * (TileH * parent.magnifier.Zoom), (TileW * parent.magnifier.Zoom), (TileH * parent.magnifier.Zoom), parent.picempty.hdc, 0, 0, vbSrcCopy
                End If
            End If
            
            index = index + 1
        Next
    Next
    parent.picclipboard.refresh
    
    parent.shpdraw.Left = 0
    parent.shpdraw.Top = 0
    parent.shpdraw.Width = parent.picclipboard.Width
    parent.shpdraw.Height = parent.picclipboard.Height
    parent.shpdraw.Visible = True
    
    Dim seltilestartx As Integer
    Dim seltileendx As Integer
    Dim seltilestarty As Integer
    Dim seltileendy As Integer
    seltilestartx = (Int((parent.hScr.value + parent.shpdraw.Left) / (TileW * parent.magnifier.Zoom)))
    seltilestarty = (Int((parent.vscr.value + parent.shpdraw.Top) / (TileH * parent.magnifier.Zoom)))
    seltileendx = seltilestartx + (parent.shpdraw.Width / (TileW * parent.magnifier.Zoom)) - 1
    seltileendy = seltilestarty + (parent.shpdraw.Height / (TileH * parent.magnifier.Zoom)) - 1
    
    Call parent.sel.SetSelRegionForPasting(seltilestartx, seltilestarty, seltileendx, seltileendy)
    
    parent.updatePreview
    BitBlt parent.picpreview.hdc, parent.shpdraw.Left, parent.shpdraw.Top, parent.shpdraw.Width, parent.shpdraw.Height, parent.picclipboard.hdc, 0, 0, vbSrcCopy
    parent.picpreview.refresh
    
End Sub

