Attribute VB_Name = "ObjectProcedures"
Option Explicit

Function SearchObject(ByRef map As frmMain, x As Integer, y As Integer) As Integer()
Dim retval() As Integer
ReDim retval(1)

Dim j As Integer
Dim i As Integer

If map.getTile(x, y) <> -1 Then
    retval(0) = x
    retval(1) = y
    SearchObject = retval
    Exit Function
End If

For j = y To y - 5 Step -1
    For i = x To x - 5 Step -1
        If map.getTile(i, j) <> -1 Then
            If isTileSpecial(map, i, j) Then
                If x - i > GetMaxSizeOfObject(map.getTile(i, j)) Then
                    'we have found one, but it can't be
                    'the one we were looking for because
                    'this one's width is shorter than the
                    'point we were coming from
                Else
                    'we prolly found it
                    retval(0) = i
                    retval(1) = j
                    SearchObject = retval
                    Exit Function
                End If
            End If
        End If
    Next
Next


End Function

Sub SearchAndDestroyObject(ByRef map As frmMain, x As Integer, y As Integer, undoch As Changes, Optional refresh As Boolean = True, Optional replacewith As Integer = 0)
If map.getTile(x, y) <> -1 Then
    Call DestroyObject(map, x, y, undoch, refresh)
    Exit Sub
End If

Dim obj() As Integer
ReDim obj(1)

obj = SearchObject(map, x, y)
Call DestroyObject(map, obj(0), obj(1), undoch, refresh, replacewith)
        
End Sub

Sub DestroyObject(ByRef map As frmMain, x As Integer, y As Integer, undoch As Changes, Optional refresh As Boolean = True, Optional replacewith As Integer = 0)
    Dim i As Integer
    Dim j As Integer
    
    Dim tilenr As Integer
    tilenr = map.getTile(x, y)
    
    For j = y To y + GetMaxSizeOfObject(tilenr)
        For i = x To x + GetMaxSizeOfObject(tilenr)
            Call map.setTile(i, j, replacewith, undoch)
            Call map.UpdateLevelTile(i, j, False)
        Next
    Next
    
    If refresh Then
        map.UpdateLevel
    End If
End Sub

Function GetMaxSizeOfObject(tilenr) As Integer
    Select Case tilenr
        Case 217
            GetMaxSizeOfObject = 1
        Case 219
            GetMaxSizeOfObject = 5
        Case 220
            GetMaxSizeOfObject = 4
        Case Else
            GetMaxSizeOfObject = 0
    End Select
End Function

Sub setObject(ByRef map As frmMain, tilenr As Integer, x As Integer, y As Integer, undoch As Changes, Optional refresh As Boolean = True)
    Dim i As Integer
    Dim j As Integer
    
    If y + GetMaxSizeOfObject(tilenr) > 1023 Or x + GetMaxSizeOfObject(tilenr) > 1023 Then
        'object cant get out of map
        Exit Sub
    End If
    
    'first, check if there are any special tiles we need to
    'remove
    For j = y To y + GetMaxSizeOfObject(tilenr)
        For i = x To x + GetMaxSizeOfObject(tilenr)
            If isTileSpecial(map, i, j) Then
                'we overlap with another, kill the other
                Call SearchAndDestroyObject(map, i, j, undoch, False)
            End If
        Next
    Next
    
    'then put the new one
    j = 0
    i = 0
    For j = y To y + GetMaxSizeOfObject(tilenr)
        For i = x To x + GetMaxSizeOfObject(tilenr)
            If i = x And j = y Then
                Call map.setTile(i, j, tilenr, undoch)
                Call map.UpdateLevelTile(i, j, False)
            Else
                Call map.setTile(i, j, -1, undoch)
                Call map.UpdateLevelTile(i, j, False)
            End If
        Next
    Next
    
    If refresh Then map.UpdateLevel
End Sub

