VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Selection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim oldx As Integer
Dim oldy As Integer
Dim curdrwwidth As Integer
Dim curdrwheight As Integer


Dim selsourcex As Integer
Dim selsourcey As Integer

Dim c_selalreadymoved As Boolean

Dim dragxcorrection As Integer
Dim dragycorrection As Integer

Enum selectionstate
    NotDrawing
    drawing
    append
End Enum

Dim c_selstate As selectionstate

Dim seltilestartx As Integer
Dim seltilestarty As Integer
Dim seltileendx As Integer
Dim seltileendy As Integer

Dim parent As frmMain

Dim undoch As Changes

Dim seltiles() As Integer

Private Sub Class_Initialize()
    selsourcex = -1
    selsourcey = -1
    
End Sub
Sub setParent(ByRef main As frmMain)
    Set parent = main
End Sub

Public Property Get selalreadymoved() As Boolean
    selalreadymoved = c_selalreadymoved
End Property

Public Property Get selstate() As selectionstate
    selstate = c_selstate
End Property

Public Property Let selstate(ByVal newselstate As selectionstate)
    c_selstate = newselstate
End Property



Sub MouseDown(Button As Integer, x As Single, y As Single)
    If c_selstate = append Then
        If parent.shpdraw.Left - 2 <= x And x <= parent.shpdraw.Left + parent.shpdraw.width + 1 + 2 And _
           parent.shpdraw.Top - 2 <= y And y <= parent.shpdraw.Top + parent.shpdraw.Height + 1 + 2 Then
            'keep appending
            c_selstate = append
            dragxcorrection = x - Int(parent.shpdraw.Left + parent.shpdraw.width / 2)
            dragycorrection = y - Int(parent.shpdraw.Top + parent.shpdraw.Height / 2)
        Else
            ApplySelection
            'we started drawing another selection
            'discard the one we were doing
            Call InitializeDrawing(x, y)
            parent.updatePreview
        End If
    Else
        'we want to start drawing
        Call InitializeDrawing(x, y)
    End If

End Sub

Sub MouseMove(x As Single, y As Single)

Select Case selstate
    
    Case drawing
        'this makes sure that the selection is fully 'selection' like
        'so you can invert left with right and such
        If x > 0 And x < parent.picpreview.width Then
            curdrwwidth = curdrwwidth + (x - oldx)
        End If
        
        If y > 0 And y < parent.picpreview.Height Then
            curdrwheight = curdrwheight + (y - oldy)
        End If
        
        'calculate the shape position for selection
        If curdrwwidth > 0 Then
            parent.shpdraw.Left = Int((x - curdrwwidth) / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
            parent.shpdraw.width = Int(curdrwwidth / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
        Else
            parent.shpdraw.Left = Int(((TileW * parent.magnifier.Zoom) + x - 1) / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
            parent.shpdraw.width = Int(Abs(curdrwwidth) / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
        End If
        
        If curdrwheight > 0 Then
            parent.shpdraw.Top = Int((y - curdrwheight) / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
            parent.shpdraw.Height = Int(curdrwheight / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
        Else
            parent.shpdraw.Top = Int(((TileH * parent.magnifier.Zoom) + y - 1) / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
            parent.shpdraw.Height = Int(Abs(curdrwheight) / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
        End If
        
        'dont go out of the picture
        If parent.shpdraw.Left < 0 Then
            parent.shpdraw.Left = 0
        End If
        If parent.shpdraw.Left + parent.shpdraw.width > parent.picpreview.width Then
            parent.shpdraw.Left = parent.picpreview.width - parent.shpdraw.width - 1
        End If
        If parent.shpdraw.Top < 0 Then parent.shpdraw.Top = 0
        If parent.shpdraw.Top + parent.shpdraw.Height > parent.picpreview.Height Then parent.shpdraw.Top = parent.picpreview.Height - parent.shpdraw.Height - 1
    
    Case append
        If SharedVar.MouseDown Then
            'we are moving the selection
            'the drag correction are the offsets from the center
            'of the selection, so that the mouse doens't have to
            'be exactly in the center in order to let the selection
            'be where the user wants
            Dim oldleft As Integer
            Dim oldtop As Integer
            oldleft = parent.shpdraw.Left
            oldtop = parent.shpdraw.Top
            
            Dim tmpleft As Integer
            tmpleft = x - parent.shpdraw.width / 2 - dragxcorrection
            parent.shpdraw.Left = Int(tmpleft / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
            'shpdraw.Left = Int(shpdraw.Left / (TileW * parent.magnifier.zoom)) * (TileW * parent.magnifier.zoom)
            
            Dim tmptop
            tmptop = (Int(y - (parent.shpdraw.Height / 2) - dragycorrection) / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
            'shpdraw.Top = (Int(y - (shpdraw.Height / 2) - dragycorrection) / (TileH * parent.magnifier.zoom)) * (TileH * parent.magnifier.zoom)
            parent.shpdraw.Top = Int(tmptop / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
            
            If oldleft <> parent.shpdraw.Left Or oldtop <> parent.shpdraw.Top Then
                'when we actually have moved
                c_selalreadymoved = True
                Call parent.updatePreview
            End If
        Else
            'update the cursor
            If parent.shpdraw.Left - 2 <= x And x <= parent.shpdraw.Left + parent.shpdraw.width + 1 + 2 And _
                parent.shpdraw.Top - 2 <= y And y <= parent.shpdraw.Top + parent.shpdraw.Height + 1 + 2 Then
                parent.picpreview.MousePointer = 15
            Else
                parent.picpreview.MousePointer = 2
            End If
        End If
End Select

oldx = x
oldy = y

End Sub

Sub MouseUp()
    If parent.magnifier.UsingPixels Then
        'stupid selection on stupid pixel level has wrong offsets
        'because of the +2, but thats needed in non-pixel level
        'to have the correct tile start
        seltilestartx = (Int((parent.hScr.value + parent.shpdraw.Left) / (TileW * parent.magnifier.Zoom)))
        seltilestarty = (Int((parent.vscr.value + parent.shpdraw.Top) / (TileH * parent.magnifier.Zoom)))
        seltileendx = seltilestartx + (parent.shpdraw.width / (TileW * parent.magnifier.Zoom)) - 1
        seltileendy = seltilestarty + (parent.shpdraw.Height / (TileH * parent.magnifier.Zoom)) - 1
    Else
        seltilestartx = (Int((parent.hScr.value + parent.shpdraw.Left + 2) / (TileW * parent.magnifier.Zoom)))
        seltilestarty = (Int((parent.vscr.value + parent.shpdraw.Top + 2) / (TileH * parent.magnifier.Zoom)))
        seltileendx = seltilestartx + (parent.shpdraw.width / (TileW * parent.magnifier.Zoom)) - 1
        seltileendy = seltilestarty + (parent.shpdraw.Height / (TileH * parent.magnifier.Zoom)) - 1
    End If

Select Case selstate
    ' //////////////// DRAWING THE SELECTION //////////
    Case drawing
        selstate = append
        
        If seltilestartx > seltileendx Or seltilestarty > seltileendy Then
            'when drawing a selection that isn't valid
            'the seltilestartx will be bigger than the seltileendx
            '(the same for y)
            'so actually we stopselecting
            StopSelecting
            Exit Sub
        End If
                  
        'check for special tiles first on all outer borders
        'of the selection and append the selection so that the
        'objects are also included if there is a part of the
        'object on it
        Dim i As Integer
        Dim j As Integer
        'this holds the return value of the function searchobject
        Dim object() As Integer
        ReDim object(1)
        
        'in order to keep the code clean, this will flag when we
        'need to restart over again
        Dim goback As Boolean
        
restart:
        goback = False
        i = 0
        j = 0
        For i = seltilestartx To seltileendx
            
            'we scan the top of the selection
            If isTileSpecial(parent, i, seltilestarty) Then
                'we found a part of an object on the first row
                'append the selection
                object = SearchObject(parent, i, seltilestarty)
                If object(0) < seltilestartx Then
                    seltilestartx = object(0)
                    goback = True
                End If
                If object(1) < seltilestarty Then
                    seltilestarty = object(1)
                    goback = True
                End If
                
                'now that we appended, we need to start over again
                If goback Then GoTo restart
            End If
            
            'we scan the bottom of the selection
            If isTileSpecial(parent, i, seltileendy) Then
                object = SearchObject(parent, i, seltileendy)
                If object(0) + GetMaxSizeOfObject(parent.getTile(object(0), object(1))) > seltileendx Then
                    seltileendx = object(0) + GetMaxSizeOfObject(parent.getTile(object(0), object(1)))
                    goback = True
                End If
                If object(1) + GetMaxSizeOfObject(parent.getTile(object(0), object(1))) > seltileendy Then
                    seltileendy = object(1) + GetMaxSizeOfObject(parent.getTile(object(0), object(1)))
                    goback = True
                End If
                
                'now that we appended, we need to start over again
                If goback Then GoTo restart
            End If
        Next
        
        For j = seltilestarty To seltileendy
            'we scan the left of the selection
            If isTileSpecial(parent, seltilestartx, j) Then
                'we found a part of an object on the first row
                'append the selection
                object = SearchObject(parent, seltilestartx, j)
                If object(0) < seltilestartx Then
                    seltilestartx = object(0)
                    goback = True
                End If
                If object(1) < seltilestarty Then
                    seltilestarty = object(1)
                    goback = True
                End If
                
                'now that we appended, we need to start over again
                If goback Then GoTo restart
            End If
            
            'we scan the right of the selection
            If isTileSpecial(parent, seltileendx, j) Then
                object = SearchObject(parent, seltileendx, j)
                If object(0) + GetMaxSizeOfObject(parent.getTile(object(0), object(1))) > seltileendx Then
                    seltileendx = object(0) + GetMaxSizeOfObject(parent.getTile(object(0), object(1)))
                    goback = True
                End If
                If object(1) + GetMaxSizeOfObject(parent.getTile(object(0), object(1))) > seltileendy Then
                    seltileendy = object(1) + GetMaxSizeOfObject(parent.getTile(object(0), object(1)))
                    goback = True
                End If
                
                'now that we appended, we need to start over again
                If goback Then GoTo restart
            End If
        Next
        
        If selsourcex = -1 Or selsourcey = -1 Then
            'only change the source when a new selection has
            'been made, and when that is, the selsource are both
            '-1
            selsourcex = seltilestartx
            selsourcey = seltilestarty
        End If
        
        'copy the selected tiles to the tile array
        ReDim seltiles(seltilestartx To seltileendx, seltilestarty To seltileendy)
        i = seltilestartx
        j = seltilestarty
        For j = seltilestarty To seltileendy
            For i = seltilestartx To seltileendx
                seltiles(i, j) = parent.getTile(i, j)
            Next
        Next
        
        SharedVar.MouseDown = False
        parent.updatePreview
        
    ' //////////////// APPENDING THE SELECTION //////////
    Case append
        If selsourcex = seltilestartx Or selsourcey = seltilestarty Then
            'source and destination is the same, don't
            'do anything
            Exit Sub
        End If

        'update the selection again
        Dim lbx As Integer
        Dim lby As Integer
        lbx = Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))
        lby = Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))
    
        If parent.magnifier.UsingPixels Then
            'dont edit the shape selection on pixel level, it screws up
            'the offset for some reason i still don't know
        Else
            parent.shpdraw.Left = (seltilestartx - lbx) * (TileW * parent.magnifier.Zoom)
            parent.shpdraw.Top = (seltilestarty - lby) * (TileH * parent.magnifier.Zoom)
            parent.shpdraw.width = (seltileendx + 1 - seltilestartx) * (TileW * parent.magnifier.Zoom)
            parent.shpdraw.Height = (seltileendy + 1 - seltilestarty) * (TileH * parent.magnifier.Zoom)
        End If
        
End Select
End Sub

Sub ApplySelection()
    Dim i As Integer
    Dim j As Integer
    
    If selsourcex = seltilestartx And selsourcey = seltilestarty Then
        'source is same as where we drop, do nothing
    Else
        parent.undoredo.ResetRedo
        Set undoch = New Changes
                
        'check here if we drop on partial objects
        i = 0
        j = 0
        For j = seltilestarty To seltileendy
            For i = seltilestartx To seltileendx
                If Not (i < 0 And j < 0 Or i > 1023 Or j > 1023) Then
                    If isTileSpecial(parent, i, j) Then
                        Call SearchAndDestroyObject(parent, i, j, undoch, False)
                    End If
                End If
            Next
        Next
        
        'copy from the selection array
        i = selsourcex
        j = selsourcey
        For j = selsourcey To selsourcey + (seltileendy - seltilestarty)
            For i = selsourcex To selsourcex + (seltileendx - seltilestartx)
                
                If i >= seltilestartx And i <= seltileendx And j >= seltilestarty And j <= seltileendy Then
                Else
                Call parent.setTile(i, j, 0, undoch)
                Call parent.UpdateLevelTile(selsourcex + (seltileendx - seltilestartx) - i, selsourcey + (seltileendy - seltilestarty) - j, False)
                End If
                
                Call parent.setTile(seltilestartx + (i - selsourcex), seltilestarty + (j - selsourcey), seltiles(i, j), undoch)
                Call parent.UpdateLevelTile(seltilestartx + (i - selsourcex), seltilestarty + (j - selsourcey), False)
                
                
            Next
        Next
    End If
    
    c_selstate = NotDrawing
    parent.shpdraw.Visible = False
    parent.shpdraw.Left = 0
    parent.shpdraw.Top = 0
    parent.shpdraw.width = 1
    parent.shpdraw.Height = 1

    If c_selalreadymoved Then
        Call parent.undoredo.AddToUndo(undoch)
    End If
        
    parent.mapchanged = True
    parent.UpdateLevel
 
End Sub

Sub UpdateSelectionTile(x As Integer, y As Integer, value As Integer, Optional refresh As Boolean = True)
    BitBlt parent.picselection.hdc, (selsourcex - x) * (TileW * parent.magnifier.Zoom)
    If refresh Then UpdateSelectionOnPreview
End Sub

Sub UpdatePicSelection(Optional refresh As Boolean = True)
    Dim i As Integer
    Dim j As Integer
    
    '*** NOT CORRECT !
    parent.picselection.width = parent.shpdraw.width
    parent.picselection.Height = parent.shpdraw.Height
    
    For j = selsourcey To selsourcey + (seltileendy - seltilestarty)
        For i = selsourcex To selsourcex + (seltileendx - seltilestartx)
            BitBlt parent.picselection.hdc, (selsourcex - i) * (TileW * parent.magnifier.Zoom), (selsourcey - j) * (TileH * parent.magnifier.Zoom), TileW * parent.magnifier.Zoom, TileH * parent.magnifier.Zoom, parent.piczoomtileset.hdc, ((tile(x, y) - 1) Mod 19) * (TileW * magnifier.Zoom), Int((tile(x, y) - 1) / 19) * (TileH * magnifier.Zoom), vbSrcCopy
        Next
    Next

    If refresh Then UpdateSelectionOnPreview
End Sub

Sub Apply_Selection()
        
        Dim i As Integer
        Dim j As Integer
        
        If selsourcex <> seltilestartx Or selsourcey <> seltilestarty Then
            parent.undoredo.ResetRedo
            Set undoch = New Changes
    
            
            If Not parent.clip.pasting Then
                'now all the objects that were in the dropping zone are
                'gone, now it's safe to copy
                i = 0
                j = 0
                Dim tmptiles() As Integer
                    ReDim tmptiles(seltileendx - seltilestartx + 1, seltileendy - seltilestarty + 1)
                    
                For j = selsourcey To selsourcey + (seltileendy - seltilestarty)
                    For i = selsourcex To selsourcex + (seltileendx - seltilestartx)
                        If Not (i < 0 And j < 0) Then
                            tmptiles(i - selsourcex, j - selsourcey) = parent.getTile(i, j)
                            Call parent.setTile(i, j, 0, undoch, c_selalreadymoved)
                            Call parent.UpdateLevelTile(i, j, False)
                        End If
                    Next
                Next
                
                'check here if we drop on partial objects
                i = 0
                j = 0
                For j = seltilestarty To seltileendy
                    For i = seltilestartx To seltileendx
                        If Not (i < 0 And j < 0 Or i > 1023 Or j > 1023) Then
                            If isTileSpecial(parent, i, j) Then
                                Call SearchAndDestroyObject(parent, i, j, undoch, False)
                            End If
                        End If
                    Next
                Next
    
                i = 0
                j = 0
                For j = seltilestarty To seltileendy
                    For i = seltilestartx To seltileendx
                        If Not (i < 0 Or j < 0 Or i > 1023 Or j > 1023) Then
                            Call parent.setTile(i, j, tmptiles(i - seltilestartx, j - seltilestarty), undoch, c_selalreadymoved)
                            Call parent.UpdateLevelTile(i, j, False)
                        End If
                    Next
                Next
            Else
                c_selalreadymoved = True
                'check here if we drop on partial objects
                i = 0
                j = 0
                For j = seltilestarty To seltileendy
                    For i = seltilestartx To seltileendx
                        If Not (i < 0 And j < 0 Or i > 1023 Or j > 1023) Then
                            If isTileSpecial(parent, i, j) Then
                                Call SearchAndDestroyObject(parent, i, j, undoch, False)
                            End If
                        End If
                    Next
                Next
    
                'we ARE pasting from clipboard so use the
                'clipboard array instead
                
                i = 0
                j = 0
                For j = seltilestarty To seltileendy
                    For i = seltilestartx To seltileendx
                        If Not (i < 0 Or j < 0 Or i > 1023 Or j > 1023) Then
                            Call parent.setTile(i, j, parent.clip.getTile(i - seltilestartx, j - seltilestarty), undoch, c_selalreadymoved)
                            Call parent.UpdateLevelTile(i, j, False)
                        End If
                    Next
                Next
                parent.clip.pasting = False
            End If
        End If
        
        StopSelecting (False)
        
        If c_selalreadymoved Then
            Call parent.undoredo.AddToUndo(undoch)
        End If
        
        parent.mapchanged = True
        parent.UpdateLevel

End Sub

Sub StopSelecting(Optional refresh As Boolean = True)
    Erase seltiles
    c_selstate = NotDrawing
    parent.shpdraw.Visible = False
    parent.shpdraw.Left = 0
    parent.shpdraw.Top = 0
    parent.shpdraw.width = 1
    parent.shpdraw.Height = 1
    
    frmGeneral.SetCurrentTool (SharedVar.curtool)
    parent.updatePreview (refresh)

End Sub

Sub DeleteSelection()
    parent.undoredo.ResetRedo
    Set undoch = New Changes
    
    Dim i As Integer
    Dim j As Integer
    For j = selsourcey To selsourcey + (seltileendy - seltilestarty)
        For i = selsourcex To selsourcex + (seltileendx - seltilestartx)
            If Not (i < 0 And j < 0) Then
                Call parent.setTile(i, j, 0, undoch)
                Call parent.UpdateLevelTile(i, j, False)
            End If
        Next
    Next

    StopSelecting (False)
    
    Call parent.undoredo.AddToUndo(undoch)
    
    parent.UpdateLevel
End Sub

Sub UpdateSelectionOnPreview()
    If Not SharedVar.MouseDown And selstate = append Then
        Dim lbx As Integer 'lowestval for x
        Dim lby As Integer 'lowestval for y
        lbx = Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))
        lby = Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))
    
        'there is currently an selection active
        'we move the preview, so we have to move the selection with it
        If parent.magnifier.UsingPixels Then
            parent.shpdraw.Left = (seltilestartx - lbx)
            parent.shpdraw.Top = (seltilestarty - lby)
            parent.shpdraw.width = (seltileendx + 1 - seltilestartx)
            parent.shpdraw.Height = (seltileendy + 1 - seltilestarty)
        Else
            parent.shpdraw.Left = (seltilestartx - lbx) * (TileW * parent.magnifier.Zoom)
            parent.shpdraw.Top = (seltilestarty - lby) * (TileH * parent.magnifier.Zoom)
            parent.shpdraw.width = (seltileendx + 1 - seltilestartx) * (TileW * parent.magnifier.Zoom)
            parent.shpdraw.Height = (seltileendy + 1 - seltilestarty) * (TileH * parent.magnifier.Zoom)
        End If
    End If
  '  Else
        
        If c_selstate = append And (curtool = T_Selection Or curtool = T_magnifier) Then
            If Not parent.clip.pasting Then
                parent.picempty.width = parent.shpdraw.width
                parent.picempty.Height = parent.shpdraw.Height
                'draw an empty space to indicate where the source of the selection
                'was, this makes the user think that the tiles are already removed,
                'but they are not, this is easier if the selection is stopped
                'so we don't have to hold the data of the original source
                'in an external array
                'draw the empty space
                BitBlt parent.picpreview.hdc, (selsourcex - Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))) * (TileW * parent.magnifier.Zoom), (selsourcey - Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))) * (TileH * parent.magnifier.Zoom), parent.shpdraw.width, parent.shpdraw.Height, parent.picempty.hdc, 0, 0, vbSrcCopy
                'draw the tiles
                BitBlt parent.picpreview.hdc, parent.shpdraw.Left, parent.shpdraw.Top, parent.shpdraw.width, parent.shpdraw.Height, parent.picselection.hdc, (selsourcex - Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))) * (TileW * parent.magnifier.Zoom), (selsourcey - Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))) * (TileH * parent.magnifier.Zoom), vbSrcCopy
            Else
                BitBlt parent.picpreview.hdc, parent.shpdraw.Left, parent.shpdraw.Top, parent.shpdraw.width, parent.shpdraw.Height, parent.picclipboard.hdc, 0, 0, vbSrcCopy
            End If
        End If
   ' End If
End Sub

Private Sub InitializeDrawing(x As Single, y As Single)
    parent.clip.pasting = False
    c_selstate = drawing
    parent.shpdraw.Visible = True
    parent.shpdraw.Left = Int(x / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
    parent.shpdraw.Top = Int(y / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
    parent.shpdraw.width = 1
    parent.shpdraw.Height = 1
    curdrwwidth = 0
    curdrwheight = 0
    oldx = Int(x / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
    oldy = Int(y / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)
    selsourcex = -1
    selsourcey = -1
    c_selalreadymoved = False

End Sub

Sub SetSelRegionForPasting(startx As Integer, starty As Integer, endx As Integer, endy As Integer)
    seltilestartx = startx
    seltileendx = endx
    seltilestarty = starty
    seltileendy = endy
    
    frmGeneral.SetCurrentTool (T_Selection)
    c_selstate = append
End Sub

Sub CutSelection()
    Call parent.clip.CutOrCopy(True, seltilestartx, seltilestarty, seltileendx, seltileendy)
End Sub

Sub CopySelection()
    Call parent.clip.CutOrCopy(False, seltilestartx, seltilestarty, seltileendx, seltileendy)
End Sub

Function IsInSelection(x As Integer, y As Integer) As Boolean
    If x < seltilestartx Or y < seltilestarty Or x > seltileendx Or y > seltileendy Then
        IsInSelection = False
    Else
        IsInSelection = True
    End If
End Function

Sub SwitchOrReplace(src As Integer, dest As Integer, replace As Boolean)
    Dim i As Integer
    Dim j As Integer
    
    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes

    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If parent.getTile(i, j) = src Then
                Call parent.setTile(i, j, dest, undoch)
                Call parent.UpdateLevelTile(i, j, False)
            ElseIf parent.getTile(i, j) = dest And Not replace Then
                Call parent.setTile(i, j, src, undoch)
                Call parent.UpdateLevelTile(i, j, False)
            End If
        Next
    Next
    
    Call parent.undoredo.AddToUndo(undoch)
    
    parent.UpdateLevel
End Sub

Sub Mirror()
    Dim i As Integer
    Dim j As Integer
    
    Dim tmp As Integer
    
    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    
    Dim tmpobjects() As Integer
    ReDim tmpobjects(seltilestartx To seltileendx, seltilestarty To seltileendy)
    
    'first off, calculate the new positions of any objects
    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendy
            tmp = parent.getTile(i, j)
            If tmp = 217 Or tmp = 219 Or tmp = 220 Then
                tmpobjects(seltilestartx + seltileendx - (i + GetMaxSizeOfObject(tmp)), j) = tmp
                Call SearchAndDestroyObject(parent, i, j, undoch, False)
            End If
        Next
    Next

    For j = seltilestarty To seltileendy
        For i = seltilestartx To Int(seltileendx - ((seltileendx - seltilestartx) / 2))
            tmp = parent.getTile(i, j)
            Call parent.setTile(i, j, parent.getTile(seltileendx - (i - seltilestartx), j), undoch, True)
            Call parent.UpdateLevelTile(i, j, False)
            Call parent.setTile(seltileendx - (i - seltilestartx), j, tmp, undoch)
            Call parent.UpdateLevelTile(seltileendx - (i - seltilestartx), j, False)
        Next
    Next
    
    'now that it's flipped we restore the objects
    i = seltilestartx
    j = seltilestarty
    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If tmpobjects(i, j) <> 0 Then
                Call setObject(parent, tmpobjects(i, j), i, j, undoch, False)
            End If
        Next
    Next

    Call parent.undoredo.AddToUndo(undoch)
    
    Call parent.UpdateLevel
End Sub

Sub Flip()
    Dim i As Integer
    Dim j As Integer
    
    Dim tmp As Integer
    
    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    
    Dim tmpobjects() As Integer
    ReDim tmpobjects(seltilestartx To seltileendx, seltilestarty To seltileendy)
    
    'first off, calculate the new positions of any objects
    For i = seltilestartx To seltileendx
        For j = seltilestarty To seltileendy
            tmp = parent.getTile(i, j)
            If tmp = 217 Or tmp = 219 Or tmp = 220 Then
                tmpobjects(i, seltilestarty + seltileendy - (j + GetMaxSizeOfObject(tmp))) = tmp
                Call SearchAndDestroyObject(parent, i, j, undoch, False)
            End If
        Next
    Next
    
    'now that the objects are temp gone we can flip the image
    i = seltilestartx
    j = seltilestarty
    For i = seltilestartx To seltileendx
        For j = seltilestarty To Int(seltileendy - ((seltileendy - seltilestarty) / 2))
            tmp = parent.getTile(i, j)
            Call parent.setTile(i, j, parent.getTile(i, seltileendy - (j - seltilestarty)), undoch, True)
            Call parent.UpdateLevelTile(i, j, False)
            Call parent.setTile(i, seltileendy - (j - seltilestarty), tmp, undoch)
            Call parent.UpdateLevelTile(i, seltileendy - (j - seltilestarty), False)
        Next
    Next
    
    'now that it's flipped we restore the objects
    i = seltilestartx
    j = seltilestarty
    For i = seltilestartx To seltileendx
        For j = seltilestarty To seltileendy
            If tmpobjects(i, j) <> 0 Then
                Call setObject(parent, tmpobjects(i, j), i, j, undoch, False)
            End If
        Next
    Next
    
    
    Call parent.undoredo.AddToUndo(undoch)
    
    Call parent.UpdateLevel

End Sub
